/* Copyright (c) 1995 by Groupe Bull.  All Rights Reserved */
/* $Id: kl_config.h,v 1.1 95/05/23 11:53:10 leon Exp $ */


/* This file contained compilation flags for use with the klone library. AS it
   is IMPORTANT that same flags are used for both making the library and using
   it, we cannot rely on external configuration */


#ifndef __KL_CONFIG_H
#define __KL_CONFIG_H


/*
 * default KLONE SEARCH PATH.
 */
#define KLONEPATH ".:~/kl:/usr/local/lib/klone"



/*
 * YOU MUST ALWAYS USE STANDARD MALLOC, else it may cause problems with Xt
 */
#define USE_STANDARD_MALLOC





#if defined(linux)
				/* Linux i386 */
#define MACHINE_TYPE linux

#define LINUX

#endif




#if defined(__alpha)
				/* DEC alpha */
#define MACHINE_TYPE alpha

#define VOID_MALLOC
#define SYSV_TIME
#define VOID_FREE
#define VOID_SIGNALS

#endif


#if defined(sparc) || defined(__sparc__)
#if defined(__SVR4) || defined(__svr4__)

				/* SUN - solaris */
#define MACHINE_TYPE sunsolaris

#define SIMPLE_LHS
#define PROTOTYPES
#define KLDLOAD


#else /* __SVR4 */
				/* sun4OS4 */
#define MACHINE_TYPE sun4

#define VOID_SIGNALS
#define KLDLOAD
#define DOUBLE_ALIGN
#define USE_IRINT

#endif
#endif



#ifndef MACHINE_TYPE
				/* set possible defaults */
#define MACHINE_TYPE default
#define SIMPLE_LHS
#define VOID_SIGNALS
#endif



#endif /* __KL_CONFIG_H */
