/* Copyright (c) 1995 by Groupe Bull.  All Rights Reserved */
/* $Id: region.h,v 1.1 95/02/27 10:33:11 leon Exp $ */

#include <X11/Intrinsic.h>

#ifndef __REGION_H
#define __REGION_H

#ifdef __cplusplus
extern "C" {
#endif



typedef struct _KnRegionRec {
    Position x1, y1, x2, y2;
    Boolean inited;
} KnRegionRec, *KnRegion;



KnRegion
KnCreateRegion();


void
KnDestroyRegion(KnRegion region);


void
KnUnionRectWithRegion(XRectangle *rect, KnRegion src, KnRegion dest);



Boolean
KnRectInRegion(KnRegion r, Position x1, Position y1, Dimension w, Dimension h);


void
KnOffsetRegion(KnRegion r, int dx, int dy);


Boolean
KnEmptyRegion(KnRegion region);


void
KnSetRegion(Display *dpy, GC gc, KnRegion r);    


#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* __REGION_H */
