/* Copyright 1994 GROUPE BULL -- See license conditions in file COPYRIGHT */
/* $Id:$ */
#ifndef __TABLE_H
#define __TABLE_H



#ifdef __cplusplus
extern "C" {
#endif



typedef struct _Hashslot {
    struct _Hashslot 	*next ;		/* collision handling */
    void		*item ;		/* item at this entry */
} HashslotRec, *Hashslot ;

typedef struct _Hashtable {
    unsigned long	(*hash_fct)() ;	/* hash function on those items */
    int			(*cmp_fct)() ;	/* compare function on those items */
    unsigned int	size ;		/* # of entries in table */
    unsigned int	item_count ;	/* # of items actually stored */
    unsigned int	mode ;		/* mode of the hashtable */
    Hashslot		*slots ;	/* table of slots */
    Hashslot		current_slot ;	/* current lookup value (FindNext) */
} HashtableRec, *Hashtable ;

/*
 * Various defines for the hashtable 'mode' field :
 */

#define HASH_OVERRIDE		1

/*
 * Macros to access slots :
 */

#define HashthableSize(h)	 ((h)->size)
#define HashtableCount(h)	 ((h)->item_count)

#define HashtableOverrideMode(h) ((h)->mode |= HASH_OVERRIDE)

/*
 * Prototypes :
 */

Hashtable HashtableMake ( unsigned int size
			 , unsigned long (*hash_fct)()
			 , int (*cmp_fct)()) ;

void *HashtableAdd  (Hashtable hashtable, void *item) ;
void *HashtableRemove (Hashtable hashtable, void *item) ;
void *HashtableFind (Hashtable hashtable, void *item) ;
void *HashtableFindNext (Hashtable hashtable) ;
int  HashtableMap (Hashtable hashtable, void (*func)(), void *closure) ;





#ifdef __cplusplus
} /* Close scope of 'extern "C"' declaration which encloses file. */
#endif




#endif /* __TABLE_H */
/* DON'T ADD ANYTHING AFTER THIS #endif */
