/* Copyright 1994 GROUPE BULL -- See license conditions in file COPYRIGHT */
static char rcsid[]="$Id:$";
#include <stdio.h>
#include <Kn/Knvas.h>


KnO layer1, layer2;

static void
DrawCB(Widget knvas, XtPointer client, XtPointer call)
{
    static KnO source = NULL;
    InteractorCallbackStruct *cs = (InteractorCallbackStruct *)call;
    if(KnCR_PICK == cs->reason) {
	if(cs->target)
	    source = cs->target;
	return;
    }
    if(KnCR_DROP == cs->reason) {
	if(source) {
	    KnO kno;
	    if(cs->target != source) {
		kno = 
		    KnCreateLink(knvas, layer1, source, cs->target);
		KlSend_clear(kno, knvas);
		source = NULL;
	    }
	}
	else {
	    KnO kno;
	    kno = KnCreateAnchor(knvas, layer2, cs->tox, cs->toy, True);
	    KlSend_clear(kno, knvas);
	    source = NULL;
	}
    }
}

int
main(int argc, char *argv[])
{
    XtAppContext context;
    Widget toplevel, knvas;
    KnO kno;
    

    toplevel = XtAppInitialize(&context, "KnvasExample", 0, 0,
			       &argc, argv, 0, 0, 0);

    knvas = 
	XtVaCreateManagedWidget("ex3", knvasWidgetClass, toplevel,
				NULL);
    layer1 = KnCreateLayer(knvas);
    layer2 = KnCreateLayer(knvas);

    kno = KnCreateAnchor(knvas, layer2, 20, 20, True);
    kno = KnCreateAnchor(knvas, layer2, 20, 100, True);
    kno = KnCreateAnchor(knvas, layer2, 100, 60, True);
    
    XtAddCallback(knvas, XtNknvasCallback, ClickCB, 0);
    
    XtRealizeWidget(toplevel);
    KnAppMainLoop(context);
}
